package jmel.code;

/**
 * An interface for type tag values, which distinguish between different
 *  sorts of types.
 */
public interface TypeTags {
	/**
	* The tag of the basic type `byte'.
	*/
	int BYTE = 1;
	
	/**
	* The tag of the basic type `char'.
	*/
	int CHAR = 2;
	
	/**
	* The tag of the basic type `short'.
	*/
	int SHORT = 3;
	
	/**
	* The tag of the basic type `int'.
	*/
	int INT = 4;
	
	/**
	* The tag of the basic type `long'.
	*/
	int LONG = 5;
	
	/**
	* The tag of the basic type `float'.
	*/
	int FLOAT = 6;
	
	/**
	* The tag of the basic type `double'.
	*/
	int DOUBLE = 7;
	
	/**
	* The tag of the basic type `boolean'.
	*/
	int BOOLEAN = 8;
	
	/**
	* The tag of the type `index'.
	*/
	int INDEX = 9;
	int STRING = 10;
	int VECTOR = 11;
	int MATRIX = 12;
	
	/**
	* The tag of the type `void'.
	*/
	int VOID = 13;
	
	/**
	* The tag of all class and interface types.
	*/
	int CLASS = 14;
	
	/**
	* The tag of all array types.
	*/
	int ARRAY = 15;
	
	/**
	* The tag of all (monomorphic) method types.
	*/
	int METHOD = 16;
	
	/**
	* The tag of all package "types".
	*/
	int PACKAGE = 17;
	
	/**
	* The tag of all type variables.
	*/
	int TYPEVAR = 18;
	
	/**
	* The tag of all polymorphic (method-) types.
	*/
	int FORALL = 19;
	
	/**
	* The tag of the bottom type "*".
	*/
	int BOT = 20;
	
	/**
	* The tag of a missing type.
	*/
	int NONE = 21;
	
	/**
	* The tag of the error type.
	*/
	int ERROR = 22;
	
	/**
	* The tag of the error type.
	*/
	int ARRAYINDEX = 23;
	
	/**
	* The number of type tags.
	*/
	int TypeTagCount = 24;
	
	/**
	* The maximum tag of a basic type.
	*/
	int lastBaseTag = MATRIX;
}
