package jmel.comp;

import jmel.util.*;
import jmel.code.*;
import jmel.tree.*;
import jmel.code.Symbol.*;


/**
 * Contains information specific to the attribute and enter
 *  passes, to be used in place of the generic field in environments.
 */
public class AttrContext {
    /**
	* The scope of local symbols.
	*/
	Scope scope = null;
	
	/**
	* The number of enclosing `static' modifiers.
	*/
	int staticLevel = 0;
	
	/**
	* Is this an environment for a this(...) or super(...) call?
	*/
	boolean isSelfCall = false;
	
	/**
	* Are we evaluating the selector of a `super' or type name?
	*/
	boolean selectSuper = false;
	
	/**
	* Duplicate this context, replacing scope field and copying all others.
	*/
	AttrContext dup(Scope scope) {
		AttrContext info = new AttrContext();
		info.scope = scope;
		info.staticLevel = staticLevel;
		info.isSelfCall = isSelfCall;
		info.selectSuper = selectSuper;
		return info;
	}
	
	/**
	* Duplicate this context, copying all fields.
	*/
	AttrContext dup() {
		return dup(scope);
	}
}
