package jmel.interp;

/**
    A specialized namespace	for Blocks, e.g. the body of a "for" statement.
	The Block acts like a child namespace but only for typed variables 
	declared within it.  Elsewhere variable assignment (including untyped
	variable usage) acts like it is part of the containing block.  
	<p>

	Note: It *must* remain possible for a BlockNameSpace to be a child of
	another BlockNameSpace and have variable propogation pass all the way
	through.  (This happens naturally and simply here). This is used in 
	BSHForStatement (see notes there).
*/
public class MethodNameSpace extends NameSpace 
{

    public MethodNameSpace( NameSpace parent ) 
		throws EvalError
	{
		super( parent, parent.name + "/MethodNameSpace" );
    }

    public void	setVariable(String name, Object	o) throws EvalError {
		super.setVariable( name, o );
   }

    public Object getVariable( String name ) {
		return getVariable( name, false );
	}
}

