package jmel.script;

import java.io.*;

public class ConvUtils {
	public static boolean toBool(boolean x) { return x; }
	public static boolean toBool(int x) { return x!=0; }
	public static boolean toBool(float x) { return (int)x!=0; }
	public static boolean toBool(double x) { return (int)x!=0; }
	public static boolean toBool(String x) { 
		if (x.equals("true")) return true;
		if (x.equals("false")) return false;
		return toInt(x)!=0; 
	}
	public static boolean toBool(MelVector x) { return toInt(x)!=0; }
	public static boolean toBool(MelMatrix x) { return toInt(x)!=0; }
	public static boolean toBool(Object x) { return toInt(x)!=0; }


	public static int toInt(boolean x) { return x ? 1 : 0; }
	public static int toInt(int x) { return x; }
	public static int toInt(float x) { return (int)x; }
	public static int toInt(double x) { return (int)x; }
	public static int toInt(String x) { 
		if ("true".equals(x)) return 1;
		if ("false".equals(x)) return 0;
		try {
			Reader r = new BufferedReader(new StringReader(x));
			StreamTokenizer st = new StreamTokenizer(r);
			st.resetSyntax();
			st.wordChars(' ', 255);
			st.whitespaceChars(0, ' ');
			st.whitespaceChars('\"', '\"');
			st.whitespaceChars('<', '<');
			st.whitespaceChars('>', '>');
			int i = 0;
			while (st.nextToken() != st.TT_EOF) {
				i = (new Double(st.sval)).intValue();
				break;
			}
			r.close();
			return i;
		} catch (NumberFormatException e) {
		} catch (IOException e) {}
		return 0;
	}
	public static int toInt(MelVector x) { return (int)x.length(); }
	public static int toInt(MelMatrix x) { return (int)x.length(); }
	public static int toInt(Object x) { 
		if (x instanceof Boolean) return ((Boolean)x).booleanValue() ? 1 : 0;
		if (x instanceof Integer) return ((Integer)x).intValue();
		if (x instanceof Float) return (int)((Float)x).floatValue();
		if (x instanceof Double) return (int)((Double)x).doubleValue();
		if (x instanceof String) return toInt((String)x);
		if (x instanceof MelVector) return toInt((MelVector)x);
		if (x instanceof MelMatrix) return toInt((MelMatrix)x);
		return 0;
	}
	
	
	public static float toFloat(boolean x) { return x ? 1.0F : 0.0F; }
	public static float toFloat(int x) { return x; }
	public static float toFloat(float x) { return x; }
	public static float toFloat(double x) { return (float)x; }
	public static float toFloat(String x) { 
		try {
			Reader r = new BufferedReader(new StringReader(x));
			StreamTokenizer st = new StreamTokenizer(r);
			st.resetSyntax();
			st.wordChars(' ', 255);
			st.whitespaceChars(0, ' ');
			st.whitespaceChars('\"', '\"');
			st.whitespaceChars('<', '<');
			st.whitespaceChars('>', '>');
			float f = 0.0F;
			while (st.nextToken() != st.TT_EOF) {
				f = (new Double(st.sval)).floatValue();
				break;
			}
			r.close();
			return f;
		} catch (NumberFormatException e) {
		} catch (IOException e) {}
		return 0.0F;
	}
	public static float toFloat(MelVector x) { return x.length(); }
	public static float toFloat(MelMatrix x) { return x.length(); }
	public static float toFloat(Object x) { 
		if (x instanceof Boolean) return ((Boolean)x).booleanValue() ? 1.0F : 0.0F;
		if (x instanceof Integer) return ((Integer)x).intValue();
		if (x instanceof Float) return ((Float)x).floatValue();
		if (x instanceof Double) return (float)((Double)x).doubleValue();
		if (x instanceof String) return toFloat((String)x);
		if (x instanceof MelVector) return toFloat((MelVector)x);
		if (x instanceof MelMatrix) return toFloat((MelMatrix)x);
		return 0.0F;
	}
	

	public static double toDouble(boolean x) { return x ? 1.0D : 0.0D; }
	public static double toDouble(int x) { return x; }
	public static double toDouble(float x) { return x; }
	public static double toDouble(double x) { return x; }
	public static double toDouble(String x) { 
		try {
			Reader r = new BufferedReader(new StringReader(x));
			StreamTokenizer st = new StreamTokenizer(r);
			st.resetSyntax();
			st.wordChars(' ', 255);
			st.whitespaceChars(0, ' ');
			st.whitespaceChars('\"', '\"');
			st.whitespaceChars('<', '<');
			st.whitespaceChars('>', '>');
			double d = 0.0D;
			while (st.nextToken() != st.TT_EOF) {
				d = (new Double(st.sval)).doubleValue();
				break;
			}
			r.close();
			return d;
		} catch (NumberFormatException e) {
		} catch (IOException e) {}
		return 0.0D;
	}
	public static double toDouble(MelVector x) { return x.length(); }
	public static double toDouble(MelMatrix x) { return x.length(); }
	public static double toDouble(Object x) { 
		if (x instanceof Boolean) return ((Boolean)x).booleanValue() ? 1.0D : 0.0D;
		if (x instanceof Integer) return ((Integer)x).intValue();
		if (x instanceof Float) return ((Float)x).floatValue();
		if (x instanceof Double) return ((Double)x).doubleValue();
		if (x instanceof String) return toDouble((String)x);
		if (x instanceof MelVector) return toDouble((MelVector)x);
		if (x instanceof MelMatrix) return toDouble((MelMatrix)x);
		return 0.0D;
	}
	

	public static String toString(int x) { return ""+x; }
	public static String toString(boolean x) { return x ? "1" : "0"; }
	public static String toString(float x) { return ""+x; }
	public static String toString(double x) { return ""+x; }
	public static String toString(String x) { return x; }
	public static String toString(MelVector x) { return x.toString(); }
	public static String toString(MelMatrix x) { return x.toString(); }
	public static String toString(Object x) { return x.toString(); }
	

	public static MelVector toVector(boolean x) { return new MelVector(x? 1 : 0); }
	public static MelVector toVector(int x) { return new MelVector(x,x,x); }
	public static MelVector toVector(float x) { return new MelVector(x,x,x); }
	public static MelVector toVector(double x) { return new MelVector((float)x,(float)x,(float)x); }
	public static MelVector toVector(String x) { return MelVector.fromString(x); }
	public static MelVector toVector(MelVector x) { return x; }
	public static MelVector toVector(MelMatrix x) { 
		float xx = 0, y = 0, z = 0;
		if (x.rows >= 1) {
			if (x.cols >= 1) xx = x.a[0][0];
			if (x.cols >= 2) y = x.a[0][1];
			if (x.cols >= 3) z = x.a[0][2];
		} 
		return new MelVector(xx, y, z);
	}
	public static MelVector toVector(Object x) { 
		if (x instanceof Boolean) return toVector(((Boolean)x).booleanValue());
		if (x instanceof Integer) return toVector(((Integer)x).intValue());
		if (x instanceof Float) return toVector(((Float)x).floatValue());
		if (x instanceof Double) return toVector(((Double)x).doubleValue());
		if (x instanceof String) return toVector((String)x);
		if (x instanceof MelVector) return (MelVector)x;
		if (x instanceof MelMatrix) return toVector((MelMatrix)x);
		return new MelVector();
	}


	public static MelMatrix toMatrix(boolean x) { return new MelMatrix(new float[][] { new float[] { x? 1 : 0 } }); }
	public static MelMatrix toMatrix(int x) { return new MelMatrix(new float[][] { new float[] { x } }); }
	public static MelMatrix toMatrix(float x) { return new MelMatrix(new float[][] { new float[] { x } }); }
	public static MelMatrix toMatrix(double x) { return new MelMatrix(new float[][] { new float[] { (float)x } }); }
	public static MelMatrix toMatrix(String x) { return MelMatrix.fromString(x); }
	public static MelMatrix toMatrix(MelVector x) { return new MelMatrix(new float[][] { new float[] { x.x, x.y, x.z } }); }
	public static MelMatrix toMatrix(MelMatrix x) { return x; }
	public static MelMatrix toMatrix(Object x) { 
		if (x instanceof Boolean) return toMatrix(((Boolean)x).booleanValue());
		if (x instanceof Integer) return toMatrix(((Integer)x).intValue());
		if (x instanceof Float) return toMatrix(((Float)x).floatValue());
		if (x instanceof Double) return toMatrix(((Double)x).doubleValue());
		if (x instanceof String) return toMatrix((String)x);
		if (x instanceof MelVector) return toMatrix((MelVector)x);
		if (x instanceof MelMatrix) return (MelMatrix)x;
		return new MelMatrix();
	}
	
	private final static Class intArray_class = (new int[] {}).getClass();
	public static MelArrayInt toArrayInt(MelArrayInt x) { return x; }
	public static MelArrayInt toArrayInt(Object x) { 
		if (x == null) return null;
		if (x instanceof MelArrayInt) return (MelArrayInt)x;
		if (x.getClass() == intArray_class) return new MelArrayInt(x);
		return null;
	}
	
	private final static Class floatArray_class = (new float[] {}).getClass();
	public static MelArrayFloat toArrayFloat(MelArrayFloat x) { return x; }
	public static MelArrayFloat toArrayFloat(Object x) { 
		if (x == null) return null;
		if (x.getClass() == floatArray_class) return new MelArrayFloat(x);
		return null;
	}
	
	private final static Class doubleArray_class = (new double[] {}).getClass();
	public static MelArrayDouble toArrayDouble(MelArrayDouble x) { return x; }
	public static MelArrayDouble toArrayDouble(Object x) { 
		if (x == null) return null;
		if (x.getClass() == doubleArray_class) return new MelArrayDouble(x);
		return null;
	}
	
	private final static Class StringArray_class = (new String[] {}).getClass();
	public static MelArrayString toArrayString(MelArrayString x) { return x; }
	public static MelArrayString toArrayString(Object x) { 
		if (x == null) return null;
		if (x.getClass() == StringArray_class) return new MelArrayString(x);
		return null;
	}
	
	private final static Class VectorArray_class = (new MelVector[] {}).getClass();
	public static MelArrayVector toArrayVector(MelArrayVector x) { return x; }
	public static MelArrayVector toArrayVector(Object x) { 
		if (x == null) return null;
		if (x.getClass() == VectorArray_class) return new MelArrayVector(x);
		return null;
	}

	public static int neg(boolean x) { return x?-1:0; }
	public static int neg(int x) { return -x; }
	public static float neg(float x) { return -x; }
	public static double neg(double x) { return -x; }
	public static String neg(String x) { return "-"+x; }
	public static MelVector neg(MelVector x) { return x.neg(); }
	public static MelMatrix neg(MelMatrix x) { return x.neg(); }
	public static Object neg(Object x) { 
		if (x instanceof Boolean) return new Integer(((Boolean)x).booleanValue()?-1:0);
		if (x instanceof Integer) return new Integer(-((Integer)x).intValue());
		if (x instanceof Float) return new Float(-((Float)x).floatValue());
		if (x instanceof Double) return new Double(-((Double)x).doubleValue());
		if (x instanceof String) return "-"+(String)x;
		if (x instanceof MelVector) return ((MelVector)x).neg();
		if (x instanceof MelMatrix) return ((MelMatrix)x).neg();
		return new MelMatrix();
	}
}
	