package jmel.script;

public class DivUtils 
{
	public static int div(boolean b1, boolean b2) { return (b1?1:0)/(b2?1:0); }
	public static int div(boolean b, int i2) { return (b?1:0)/i2; }
	public static float div(boolean b, float f) { return (b?1:0)/f; }
	public static double div(boolean b, double d) { return (b?1:0)/d; }
	public static String div(boolean b, String s) { return b+"/"+s; }
	public static float div(boolean b, MelVector v) { return (b?1:0)/v.length(); }
	public static float div(boolean b, MelMatrix m) { return (b?1:0)/m.length(); }
	public static Object div(boolean b, Object o) { 
		int value = b ? 1 : 0;
		if (o instanceof Boolean) return new Integer(value/(((Boolean)o).booleanValue()?1:0)); 
		if (o instanceof Integer) return new Integer(value/((Integer)o).intValue()); 
		if (o instanceof Float) return new Float(value/((Float)o).floatValue()); 
		if (o instanceof Double) return new Double(value/((Double)o).doubleValue()); 
		if (o instanceof String) return b+"/"+(String)o; 
		if (o instanceof MelVector) return new Float(value/((MelVector)o).length());
		if (o instanceof MelMatrix) return new Float(value/((MelMatrix)o).length());
		return new Integer(0);
	}


	public static int div(int i, boolean b) { return i/(b?1:0); }
	public static int div(int i1, int i2) { return i1/i2; }
	public static float div(int i, float f) { return i/f; }
	public static double div(int i, double d) { return i/d; }
	public static String div(int i, String s) { return i+"/"+s; }
	public static float div(int i, MelVector v) { return i/v.length(); }
	public static float div(int i, MelMatrix m) { return i/m.length(); }
	public static Object div(int i, Object o) { 
		if (o instanceof Boolean) return new Integer(i/(((Boolean)o).booleanValue()?1:0)); 
		if (o instanceof Integer) return new Integer(i/((Integer)o).intValue()); 
		if (o instanceof Float) return new Float(i/((Float)o).floatValue()); 
		if (o instanceof Double) return new Double(i/((Double)o).doubleValue()); 
		if (o instanceof String) return i+"/"+(String)o; 
		if (o instanceof MelVector) return new Float(i/((MelVector)o).length());
		if (o instanceof MelMatrix) return new Float(i/((MelMatrix)o).length());
		return new Integer(0);
	}
	
	
	public static float div(float f, boolean b) { return f/(b?1.0F:0.0F); }
	public static float div(float f, int i) { return f/i; }
	public static float div(float f1, float f2) { return f1/f2; }
	public static double div(float f, double d) { return f/d; }
	public static String div(float f, String s) { return f+"/"+s; }
	public static float div(float f, MelVector v) { return f/v.length(); }
	public static float div(float f, MelMatrix m) { return f/m.length(); }
	public static Object div(float f, Object o) {
		if (o instanceof Boolean) return new Float(f/(((Boolean)o).booleanValue()?1:0)); 
		if (o instanceof Integer) return new Float(f/((Integer)o).intValue()); 
		if (o instanceof Float) return new Float(f/((Float)o).floatValue()); 
		if (o instanceof Double) return new Double(f/((Double)o).doubleValue()); 
		if (o instanceof String) return f+"/"+(String)o; 
		if (o instanceof MelVector) return new Float(f/((MelVector)o).length());
		if (o instanceof MelMatrix) return new Float(f/((MelMatrix)o).length());
		return new Integer(0);
	}
	
	
	public static double div(double d, boolean b) { return d/(b?1.0D:0.0D); }
	public static double div(double d, int i) { return d/i; }
	public static double div(double d, float f) { return d/f; }
	public static double div(double d1, double d2) { return d1/d2; }
	public static String div(double d, String s) { return d+"/"+s; }
	public static float div(double d, MelVector v) { return ((float)d)/v.length(); }
	public static float div(double d, MelMatrix m) { return ((float)d)/m.length(); }
	public static Object div(double d, Object o) { 
		if (o instanceof Boolean) return new Double(d/(((Boolean)o).booleanValue()?1:0)); 
		if (o instanceof Integer) return new Double(d/((Integer)o).intValue()); 
		if (o instanceof Float) return new Double(d/((Float)o).floatValue()); 
		if (o instanceof Double) return new Double(d/((Double)o).doubleValue()); 
		if (o instanceof String) return d+"/"+(String)o; 
		if (o instanceof MelVector) return new Float(((float)d)/((MelVector)o).length());
		if (o instanceof MelMatrix) return new Float(((float)d)/((MelMatrix)o).length());
		return new Integer(0);
	}
	
	
	public static String div(String s, boolean b) { return s+"/"+(b?"1":"0"); }
	public static String div(String s, int i) { return s+"/"+i; }
	public static String div(String s, float f) { return s+"/"+f; }
	public static String div(String s, double d) { return s+"/"+d; }
	public static String div(String s1, String s2) { return s1+"/"+s2; }
	public static String div(String s, MelVector v) { return s+"/"+v.toString(); }
	public static String div(String s, MelMatrix m) { return s+"/"+m.toString(); }
	public static String div(String s, Object o) { return s+"/"+o.toString(); }
	
	
	public static MelVector div(MelVector v, boolean b) { return v.div(b?1:0); }
	public static MelVector div(MelVector v, int i) { return v.div(i); }
	public static MelVector div(MelVector v, float f) { return v.div(f); }
	public static MelVector div(MelVector v, double d) { return v.div((float)d); }
	public static String div(MelVector v, String s) { return v.toString()+"/"+s; }
	public static MelVector div(MelVector v1, MelVector v2) { return v1.div(v2); }
	public static MelVector div(MelVector v, MelMatrix m) { return v.div(ConvUtils.toVector(m)); }
	public static Object div(MelVector v, Object o) { 
		if (o instanceof Boolean) return v.div(((Boolean)o).booleanValue()?1:0); 
		if (o instanceof Integer) return v.div(((Integer)o).intValue()); 
		if (o instanceof Float) return v.div(((Float)o).floatValue()); 
		if (o instanceof Double) return v.div((float)((Double)o).doubleValue()); 
		if (o instanceof String) return v+"/"+(String)o; 
		if (o instanceof MelVector) return v.div((MelVector)o); 
		if (o instanceof MelMatrix) return v.div(ConvUtils.toVector((MelMatrix)o)); 
		return new Integer(0);
	}
	

	public static MelMatrix div(MelMatrix m, boolean b) { return m.div(b?1:0); }
	public static MelMatrix div(MelMatrix m, int i) { return m.div(i); }
	public static MelMatrix div(MelMatrix m, float f) { return m.div(f); }
	public static MelMatrix div(MelMatrix m, double d) { return m.div((float)d); }
	public static String div(MelMatrix m, String s) { return m.toString()+"/"+s; }
	public static MelMatrix div(MelMatrix m, MelVector v) { return m.div(ConvUtils.toMatrix(v)); }
	public static MelMatrix div(MelMatrix m1, MelMatrix m2) { return m1.div(m2); }
	public static Object div(MelMatrix m, Object o) { 
		if (o instanceof Boolean) return m.div(((Boolean)o).booleanValue()?1:0); 
		if (o instanceof Integer) return m.div(((Integer)o).intValue()); 
		if (o instanceof Float) return m.div(((Float)o).floatValue()); 
		if (o instanceof Double) return m.div((float)((Double)o).doubleValue()); 
		if (o instanceof String) return m+"/"+(String)o; 
		if (o instanceof MelVector) return m.div(ConvUtils.toMatrix((MelVector)o)); 
		if (o instanceof MelMatrix) return m.div((MelMatrix)o); 
		return new Integer(0);
	}
	

	public static Object div(Object o, boolean b) { return div(o, new Boolean(b)); }
	public static Object div(Object o, int i) { return div(o, new Integer(i)); }
	public static Object div(Object o, float f) { return div(o, new Float(f)); }
	public static Object div(Object o, double d) { return div(o, new Double(d)); }
	public static String div(Object o, String s) { return o.toString()+"/"+s; }
	public static Object div(Object o, MelVector v) { 
		if (o instanceof Integer) return new Float(div(((Integer)o).intValue(), v)); 
		if (o instanceof Boolean) return new Float(div(((Boolean)o).booleanValue(), v)); 
		if (o instanceof Float) return new Float(div(((Float)o).floatValue(), v)); 
		if (o instanceof Double) return new Float(div(((Double)o).doubleValue(), v)); 
		if (o instanceof String) return o+"/"+v.toString(); 
		if (o instanceof MelVector) return div((MelVector)o, v); 
		if (o instanceof MelMatrix) return div((MelMatrix)o, v); 
		return new Integer(0);
	}
	public static Object div(Object o, MelMatrix m) { 
		if (o instanceof Integer) return new Float(div(((Integer)o).intValue(), m)); 
		if (o instanceof Boolean) return new Float(div(((Boolean)o).booleanValue(), m)); 
		if (o instanceof Float) return new Float(div(((Float)o).floatValue(), m)); 
		if (o instanceof Double) return new Float(div(((Double)o).doubleValue(), m)); 
		if (o instanceof String) return o+"/"+m.toString(); 
		if (o instanceof MelVector) return div((MelVector)o, m); 
		if (o instanceof MelMatrix) return div((MelMatrix)o, m); 
		return new Integer(0);
	}
	public static Object div(Object o1, Object o2) { 
		if (o2 instanceof Integer) return div(o1, ((Integer)o2).intValue()); 
		if (o2 instanceof Boolean) return div(o1, ((Boolean)o2).booleanValue()); 
		if (o2 instanceof Float) return div(o1, ((Float)o2).floatValue()); 
		if (o2 instanceof Double) return div(o1, ((Double)o2).doubleValue()); 
		if (o2 instanceof String) return div(o1, (String)o2); 
		if (o2 instanceof MelVector) return div(o1, (MelVector)o2); 
		if (o2 instanceof MelMatrix) return div(o1, (MelMatrix)o2); 
		return new Integer(0);
	}
}