package jmel.script;

public class EqUtils 
{
	public static boolean eq(boolean b1, boolean b2) { return b1==b2; }
	public static boolean eq(boolean b, int i) { return (b?1:0)==i; }
	public static boolean eq(boolean b, float f) { return (b?1:0)==f; }
	public static boolean eq(boolean b, double d) { return (b?1:0)==d; }
	public static boolean eq(boolean b, String s) { return (b?"1":"0").equals(s); }
	public static boolean eq(boolean b, MelVector v) { return (b?1:0)==v.length(); }
	public static boolean eq(boolean b, MelMatrix m) { return (b?1:0)==m.length(); }
	public static boolean eq(boolean b, Object o) { 
		int value = b ? 1 : 0;
		if (o instanceof Boolean) return b==((Boolean)o).booleanValue(); 
		if (o instanceof Integer) return value==((Integer)o).intValue(); 
		if (o instanceof Float) return value==((Float)o).floatValue(); 
		if (o instanceof Double) return value==((Double)o).doubleValue(); 
		if (o instanceof String) return (b?"1":"0").equals((String)o); 
		if (o instanceof MelVector) return value==((MelVector)o).length();
		if (o instanceof MelMatrix) return value==((MelMatrix)o).length();
		return false;
	}


	public static boolean eq(int i, boolean b) { return i==(b?1:0); }
	public static boolean eq(int i1, int i2) { return i1==i2; }
	public static boolean eq(int i, float f) { return i==(int)f; }
	public static boolean eq(int i, double d) { return i==(int)d; }
	public static boolean eq(int i, String s) { return s.equals(""+i); }
	public static boolean eq(int i, MelVector v) { return i==(int)v.length(); }
	public static boolean eq(int i, MelMatrix m) { return i==(int)m.length(); }
	public static boolean eq(int i, Object o) { 
		if (o instanceof Boolean) return i==(((Boolean)o).booleanValue()?1:0); 
		if (o instanceof Integer) return i==((Integer)o).intValue(); 
		if (o instanceof Float) return i==(int)((Float)o).floatValue(); 
		if (o instanceof Double) return i==(int)((Double)o).doubleValue(); 
		if (o instanceof String) return ((String)o).equals(""+i); 
		if (o instanceof MelVector) return i==(int)((MelVector)o).length();
		if (o instanceof MelMatrix) return i==(int)((MelMatrix)o).length();
		return false;
	}
	
	
	public static boolean eq(float f, boolean b) { return f==(b?1:0); }
	public static boolean eq(float f, int i) { return f==i; }
	public static boolean eq(float f1, float f2) { return f1==f2; }
	public static boolean eq(float f, double d) { return f==(float)d; }
	public static boolean eq(float f, String s) { return s.equals(""+f); }
	public static boolean eq(float f, MelVector v) { return f==v.length(); }
	public static boolean eq(float f, MelMatrix m) { return f==m.length(); }
	public static boolean eq(float f, Object o) { 
		if (o instanceof Boolean) return f==(((Boolean)o).booleanValue()?1:0); 
		if (o instanceof Integer) return f==((Integer)o).intValue(); 
		if (o instanceof Float) return f==((Float)o).floatValue(); 
		if (o instanceof Double) return f==(float)((Double)o).doubleValue(); 
		if (o instanceof String) return ((String)o).equals(""+f); 
		if (o instanceof MelVector) return f==((MelVector)o).length();
		if (o instanceof MelMatrix) return f==((MelMatrix)o).length();
		return false;
	}
	
	
	public static boolean eq(double d, boolean b) { return d==(b?1:0); }
	public static boolean eq(double d, int i) { return d==i; }
	public static boolean eq(double d, float f) { return d==f; }
	public static boolean eq(double d1, double d2) { return d1==d2; }
	public static boolean eq(double d, String s) { return s.equals(""+d); }
	public static boolean eq(double d, MelVector v) { return d==v.length(); }
	public static boolean eq(double d, MelMatrix m) { return d==m.length(); }
	public static boolean eq(double d, Object o) { 
		if (o instanceof Boolean) return d==(((Boolean)o).booleanValue()?1:0); 
		if (o instanceof Integer) return d==((Integer)o).intValue(); 
		if (o instanceof Float) return d==((Float)o).floatValue(); 
		if (o instanceof Double) return d==((Double)o).doubleValue(); 
		if (o instanceof String) return ((String)o).equals(""+d); 
		if (o instanceof MelVector) return d==((MelVector)o).length();
		if (o instanceof MelMatrix) return d==((MelMatrix)o).length();
		return false;
	}
	
	
	public static boolean eq(String s, boolean b) { return s.equals(b?"1":"0"); }
	public static boolean eq(String s, int i) { return s.equals(""+i); }
	public static boolean eq(String s, float f) { return s.equals(""+f); }
	public static boolean eq(String s, double d) { return s.equals(""+d); }
	public static boolean eq(String s1, String s2) { return s1.equals(s2); }
	public static boolean eq(String s, MelVector v) { return s.equals(v.toString()); }
	public static boolean eq(String s, MelMatrix m) { return s.equals(m.toString()); }
	public static boolean eq(String s, Object o) { return s.equals(o.toString()); }
	
	
	public static boolean eq(MelVector v, boolean b) { return v.equals(ConvUtils.toVector(b)); }
	public static boolean eq(MelVector v, int i) { return v.equals(ConvUtils.toVector(i)); }
	public static boolean eq(MelVector v, float f) { return v.equals(ConvUtils.toVector(f)); }
	public static boolean eq(MelVector v, double d) { return v.equals(ConvUtils.toVector(d)); }
	public static boolean eq(MelVector v, String s) { return v.equals(ConvUtils.toVector(s)); }
	public static boolean eq(MelVector v1, MelVector v2) { return v1.equals(v2); }
	public static boolean eq(MelVector v, MelMatrix m) { return v.equals(ConvUtils.toVector(m)); }
	public static boolean eq(MelVector v, Object o) { 
		if (o instanceof Boolean) return v.equals(ConvUtils.toVector(((Boolean)o).booleanValue()?1:0)); 
		if (o instanceof Integer) return v.equals(ConvUtils.toVector(((Integer)o).intValue())); 
		if (o instanceof Float) return v.equals(ConvUtils.toVector(((Float)o).floatValue())); 
		if (o instanceof Double) return v.equals(ConvUtils.toVector(((Double)o).doubleValue())); 
		if (o instanceof String) return v.equals(ConvUtils.toVector((String)o)); 
		if (o instanceof MelVector) return v.equals((MelVector)o);
		if (o instanceof MelMatrix) return v.equals(ConvUtils.toVector((MelMatrix)o));
		return false;
	}
	

	public static boolean eq(MelMatrix m, boolean b) { return m.length()==(b?1:0); }
	public static boolean eq(MelMatrix m, int i) { return m.length()==i; }
	public static boolean eq(MelMatrix m, float f) { return m.length()==f; }
	public static boolean eq(MelMatrix m, double d) { return m.length()==(float)d; }
	public static boolean eq(MelMatrix m, String s) { return s.equals(""+m.length()); }
	public static boolean eq(MelMatrix m, MelVector v) { return m.length()==v.length(); }
	public static boolean eq(MelMatrix m1, MelMatrix m2) { return m1.length()==m2.length(); }
	public static boolean eq(MelMatrix m, Object o) { 
		if (o instanceof Boolean) return m.length()==(((Boolean)o).booleanValue()?1:0); 
		if (o instanceof Integer) return m.length()==((Integer)o).intValue(); 
		if (o instanceof Float) return m.length()==((Float)o).floatValue(); 
		if (o instanceof Double) return m.length()==((Double)o).doubleValue(); 
		if (o instanceof String) return ((String)o).equals(""+m.length()); 
		if (o instanceof MelVector) return m.length()==((MelVector)o).length();
		if (o instanceof MelMatrix) return m.length()==((MelMatrix)o).length();
		return false;
	}
	

	public static boolean eq(Object o, boolean b) { return eq(o, b); }
	public static boolean eq(Object o, int i) { return eq(o, new Integer(i)); }
	public static boolean eq(Object o, float f) { return eq(o, new Float(f)); }
	public static boolean eq(Object o, double d) { return eq(o, new Double(d)); }
	public static boolean eq(Object o, String s) { return o.toString()==s; }
	public static boolean eq(Object o, MelVector v) { 
		if (o instanceof Integer) return eq(((Integer)o).intValue(), v); 
		if (o instanceof Boolean) return eq(((Boolean)o).booleanValue(), v); 
		if (o instanceof Float) return eq(((Float)o).floatValue(), v); 
		if (o instanceof Double) return eq(((Double)o).doubleValue(), v); 
		if (o instanceof String) return o.equals(v.toString()); 
		if (o instanceof MelVector) return eq((MelVector)o, v); 
		if (o instanceof MelMatrix) return eq((MelMatrix)o, v); 
		return false;
	}
	public static boolean eq(Object o, MelMatrix m) { 
		if (o instanceof Integer) return eq(((Integer)o).intValue(), m); 
		if (o instanceof Boolean) return eq(((Boolean)o).booleanValue(), m); 
		if (o instanceof Float) return eq(((Float)o).floatValue(), m); 
		if (o instanceof Double) return eq(((Double)o).doubleValue(), m); 
		if (o instanceof String) return o.equals(m.toString()); 
		if (o instanceof MelVector) return eq((MelVector)o, m); 
		if (o instanceof MelMatrix) return eq((MelMatrix)o, m); 
		return false;
	}
	public static boolean eq(Object o1, Object o2) { 
		if (o2 instanceof Integer) return eq(o1, ((Integer)o2).intValue()); 
		if (o2 instanceof Boolean) return eq(o1, ((Boolean)o2).booleanValue()); 
		if (o2 instanceof Float) return eq(o1, ((Float)o2).floatValue()); 
		if (o2 instanceof Double) return eq(o1, ((Double)o2).doubleValue()); 
		if (o2 instanceof String) return eq(o1, (String)o2); 
		if (o2 instanceof MelVector) return eq(o1, (MelVector)o2); 
		if (o2 instanceof MelMatrix) return eq(o1, (MelMatrix)o2); 
		return false;
	}
}