package jmel.script;

import java.lang.reflect.Array;

public abstract class MelArray
{
	private Class elemtype;
	private Object value;
	
	public MelArray(Class elemtype, Object value) {
		this.elemtype = elemtype;
		this.value = value;
	}
	
	Object readElement(int i) { return Array.get(value, i); }
	Object readElement(int i, int j) { return Array.get(Array.get(value, i), j); }

	void writeElement(int i, Object o) { 
		int length = Array.getLength(value);
		if (length <= i) {
			Object tmp = Array.newInstance(elemtype, i+1);
			System.arraycopy(value, 0, tmp, 0, length);
			value = tmp;
		}
		Array.set(value, i, o); 
	}
	void writeElement(int i, int j, Object o) { 
		Array.set(Array.get(value, i), j, o); 
	}

	public void removeElement(int i) { 
		int length = Array.getLength(value);
		if (i < length) {
			Object tmp = Array.newInstance(elemtype, length-1);
			System.arraycopy(value, 0, tmp, 0, i);
			System.arraycopy(value, i+1, tmp, i, length-i-1);
			value = tmp;
		}
	}
	
	public int getSize() { return Array.getLength(value); }
	
	public void clear() { 
		value = Array.newInstance(elemtype, 0);
	}
	
	public String toString() {
		int length = Array.getLength(value);
		String tmp = "";
		for (int i = 0; i < length; i++) {
			tmp += Array.get(value, i).toString();
			if (i < length-1) tmp += " ";
		}
		return tmp;
	}
	
	public Object getValue() {
		return value;
	}
	
	public Object getValue(int i) {
		return readElement(i);
	}
	
	public Object getValue(int i, int j) {
		return readElement(i,j);
	}
	
	public void setValue(int i, Object val) {
		writeElement(i,val);
	}
	
	public void setValue(int i, int j, Object val) {
		writeElement(i,j,val);
	}
}