package jmel.script;

public class MulUtils 
{
	public static int mul(boolean b1, boolean b2) { return (b1?1:0)*(b2?1:0); }
	public static int mul(boolean b, int i2) { return (b?1:0)*i2; }
	public static float mul(boolean b, float f) { return (b?1:0)*f; }
	public static double mul(boolean b, double d) { return (b?1:0)*d; }
	public static String mul(boolean b, String s) { return b+"*"+s; }
	public static MelVector mul(boolean b, MelVector v) { return v.mul(b?1:0); }
	public static MelMatrix mul(boolean b, MelMatrix m) { return m.mul(b?1:0); }
	public static Object mul(boolean b, Object o) { 
		int value = b ? 1 : 0;
		if (o instanceof Boolean) return new Integer(value*(((Boolean)o).booleanValue()?1:0)); 
		if (o instanceof Integer) return new Integer(value*((Integer)o).intValue()); 
		if (o instanceof Float) return new Float(value*((Float)o).floatValue()); 
		if (o instanceof Double) return new Double(value*((Double)o).doubleValue()); 
		if (o instanceof String) return b+"*"+(String)o; 
		if (o instanceof MelVector) return ((MelVector)o).mul(value); 
		if (o instanceof MelMatrix) return ((MelMatrix)o).mul(value); 
		return new Integer(0);
	}


	public static int mul(int i, boolean b) { return i*(b?1:0); }
	public static int mul(int i1, int i2) { return i1*i2; }
	public static float mul(int i, float f) { return i*f; }
	public static double mul(int i, double d) { return i*d; }
	public static String mul(int i, String s) { return i+"*"+s; }
	public static MelVector mul(int i, MelVector v) { return v.mul(i); }
	public static MelMatrix mul(int i, MelMatrix m) { return m.mul(i); }
	public static Object mul(int i, Object o) { 
		if (o instanceof Boolean) return new Integer(i*(((Boolean)o).booleanValue()?1:0)); 
		if (o instanceof Integer) return new Integer(i*((Integer)o).intValue()); 
		if (o instanceof Float) return new Float(i*((Float)o).floatValue()); 
		if (o instanceof Double) return new Double(i*((Double)o).doubleValue()); 
		if (o instanceof String) return i+"*"+(String)o; 
		if (o instanceof MelVector) return ((MelVector)o).mul(i); 
		if (o instanceof MelMatrix) return ((MelMatrix)o).mul(i); 
		return new Integer(0);
	}
	
	
	public static float mul(float f, boolean b) { return f*(b?1.0F:0.0F); }
	public static float mul(float f, int i) { return f*i; }
	public static float mul(float f1, float f2) { return f1*f2; }
	public static double mul(float f, double d) { return f*d; }
	public static String mul(float f, String s) { return f+"*"+s; }
	public static MelVector mul(float f, MelVector v) { return v.mul(f); }
	public static MelMatrix mul(float f, MelMatrix m) { return m.mul(f); }
	public static Object mul(float f, Object o) {
		if (o instanceof Boolean) return new Float(f*(((Boolean)o).booleanValue()?1:0)); 
		if (o instanceof Integer) return new Float(f*((Integer)o).intValue()); 
		if (o instanceof Float) return new Float(f*((Float)o).floatValue()); 
		if (o instanceof Double) return new Double(f*((Double)o).doubleValue()); 
		if (o instanceof String) return f+"*"+(String)o; 
		if (o instanceof MelVector) return ((MelVector)o).mul(f); 
		if (o instanceof MelMatrix) return ((MelMatrix)o).mul(f); 
		return new Integer(0);
	}
	
	
	public static double mul(double d, boolean b) { return d*(b?1.0D:0.0D); }
	public static double mul(double d, int i) { return d*i; }
	public static double mul(double d, float f) { return d*f; }
	public static double mul(double d1, double d2) { return d1*d2; }
	public static String mul(double d, String s) { return d+"*"+s; }
	public static MelVector mul(double d, MelVector v) { return v.mul((float)d); }
	public static MelMatrix mul(double d, MelMatrix m) { return m.mul((float)d); }
	public static Object mul(double d, Object o) { 
		if (o instanceof Boolean) return new Double(d*(((Boolean)o).booleanValue()?1:0)); 
		if (o instanceof Integer) return new Double(d*((Integer)o).intValue()); 
		if (o instanceof Float) return new Double(d*((Float)o).floatValue()); 
		if (o instanceof Double) return new Double(d*((Double)o).doubleValue()); 
		if (o instanceof String) return d+"*"+(String)o; 
		if (o instanceof MelVector) return ((MelVector)o).mul((float)d); 
		if (o instanceof MelMatrix) return ((MelMatrix)o).mul((float)d); 
		return new Integer(0);
	}
	
	
	public static String mul(String s, boolean b) { return s+"*"+(b?"1":"0"); }
	public static String mul(String s, int i) { return s+"*"+i; }
	public static String mul(String s, float f) { return s+"*"+f; }
	public static String mul(String s, double d) { return s+"*"+d; }
	public static String mul(String s1, String s2) { return s1+"*"+s2; }
	public static String mul(String s, MelVector v) { return s+"*"+v.toString(); }
	public static String mul(String s, MelMatrix m) { return s+"*"+m.toString(); }
	public static String mul(String s, Object o) { return s+"*"+o.toString(); }
	
	
	public static MelVector mul(MelVector v, boolean b) { return v.mul(b?1:0); }
	public static MelVector mul(MelVector v, int i) { return v.mul(i); }
	public static MelVector mul(MelVector v, float f) { return v.mul(f); }
	public static MelVector mul(MelVector v, double d) { return v.mul((float)d); }
	public static String mul(MelVector v, String s) { return v.toString()+"*"+s; }
	public static float mul(MelVector v1, MelVector v2) { return v1.mul(v2); }
	public static float mul(MelVector v, MelMatrix m) { return v.mul(ConvUtils.toVector(m)); }
	public static Object mul(MelVector v, Object o) { 
		if (o instanceof Boolean) return v.mul(((Boolean)o).booleanValue()?1:0); 
		if (o instanceof Integer) return v.mul(((Integer)o).intValue()); 
		if (o instanceof Float) return v.mul(((Float)o).floatValue()); 
		if (o instanceof Double) return v.mul((float)((Double)o).doubleValue()); 
		if (o instanceof String) return v+"*"+(String)o; 
		if (o instanceof MelVector) return new Float(v.mul((MelVector)o)); 
		if (o instanceof MelMatrix) return new Float(v.mul(ConvUtils.toVector((MelMatrix)o))); 
		return new Integer(0);
	}
	

	public static MelMatrix mul(MelMatrix m, boolean b) { return m.mul(b?1:0); }
	public static MelMatrix mul(MelMatrix m, int i) { return m.mul(i); }
	public static MelMatrix mul(MelMatrix m, float f) { return m.mul(f); }
	public static MelMatrix mul(MelMatrix m, double d) { return m.mul((float)d); }
	public static String mul(MelMatrix m, String s) { return m.toString()+"*"+s; }
	public static MelVector mul(MelMatrix m, MelVector v) { return m.mul(v); }
	public static MelMatrix mul(MelMatrix m1, MelMatrix m2) { return m1.mul(m2); }
	public static Object mul(MelMatrix m, Object o) { 
		if (o instanceof Boolean) return m.mul(((Boolean)o).booleanValue()?1:0); 
		if (o instanceof Integer) return m.mul(((Integer)o).intValue()); 
		if (o instanceof Float) return m.mul(((Float)o).floatValue()); 
		if (o instanceof Double) return m.mul((float)((Double)o).doubleValue()); 
		if (o instanceof String) return m+"*"+(String)o; 
		if (o instanceof MelVector) return m.mul((MelVector)o); 
		if (o instanceof MelMatrix) return m.mul((MelMatrix)o); 
		return new Integer(0);
	}
	

	public static Object mul(Object o, boolean b) { return mul(o, new Boolean(b)); }
	public static Object mul(Object o, int i) { return mul(o, new Integer(i)); }
	public static Object mul(Object o, float f) { return mul(o, new Float(f)); }
	public static Object mul(Object o, double d) { return mul(o, new Double(d)); }
	public static String mul(Object o, String s) { return o.toString()+"*"+s; }
	public static Object mul(Object o, MelVector v) { 
		if (o instanceof Integer) return mul(((Integer)o).intValue(), v); 
		if (o instanceof Boolean) return mul(((Boolean)o).booleanValue(), v); 
		if (o instanceof Float) return mul(((Float)o).floatValue(), v); 
		if (o instanceof Double) return mul(((Double)o).doubleValue(), v); 
		if (o instanceof String) return o+"*"+v.toString(); 
		if (o instanceof MelVector) return new Float(mul((MelVector)o, v)); 
		if (o instanceof MelMatrix) return mul((MelMatrix)o, v); 
		return new Integer(0);
	}
	public static Object mul(Object o, MelMatrix m) { 
		if (o instanceof Integer) return mul(((Integer)o).intValue(), m); 
		if (o instanceof Boolean) return mul(((Boolean)o).booleanValue(), m); 
		if (o instanceof Float) return mul(((Float)o).floatValue(), m); 
		if (o instanceof Double) return mul(((Double)o).doubleValue(), m); 
		if (o instanceof String) return o+"*"+m.toString(); 
		if (o instanceof MelVector) return new Float(mul((MelVector)o, m)); 
		if (o instanceof MelMatrix) return mul((MelMatrix)o, m); 
		return new Integer(0);
	}
	public static Object mul(Object o1, Object o2) { 
		if (o2 instanceof Integer) return mul(o1, ((Integer)o2).intValue()); 
		if (o2 instanceof Boolean) return mul(o1, ((Boolean)o2).booleanValue()); 
		if (o2 instanceof Float) return mul(o1, ((Float)o2).floatValue()); 
		if (o2 instanceof Double) return mul(o1, ((Double)o2).doubleValue()); 
		if (o2 instanceof String) return mul(o1, (String)o2); 
		if (o2 instanceof MelVector) return mul(o1, (MelVector)o2); 
		if (o2 instanceof MelMatrix) return mul(o1, (MelMatrix)o2); 
		return new Integer(0);
	}
}