package jmel.script;

public class PowUtils 
{
	public static float pow(boolean b1, boolean b2) { return (float)Math.pow(b1?1:0,b2?1:0); }
	public static float pow(boolean b, int i2) { return (float)Math.pow(b?1:0,i2); }
	public static float pow(boolean b, float f) { return (float)Math.pow(b?1:0,f); }
	public static double pow(boolean b, double d) { return Math.pow(b?1:0,d); }
	public static String pow(boolean b, String s) { return b+"^"+s; }
	public static float pow(boolean b, MelVector v) { return (float)Math.pow(b?1:0, v.length()); }
	public static float pow(boolean b, MelMatrix m) { return (float)Math.pow(b?1:0, m.length()); }
	public static Object pow(boolean b, Object o) { 
		int value = b ? 1 : 0;
		if (o instanceof Boolean) return new Float(Math.pow(value, (((Boolean)o).booleanValue()?1:0))); 
		if (o instanceof Integer) return new Float(Math.pow(value, ((Integer)o).intValue())); 
		if (o instanceof Float) return new Float(Math.pow(value, ((Float)o).floatValue())); 
		if (o instanceof Double) return new Double(Math.pow(value, ((Double)o).doubleValue())); 
		if (o instanceof String) return b+"^"+(String)o; 
		if (o instanceof MelVector) return new Float((float)Math.pow(value, ((MelVector)o).length()));
		if (o instanceof MelMatrix) return new Float((float)Math.pow(value, ((MelMatrix)o).length()));
		return new Integer(0);
	}


	public static float pow(int i, boolean b) { return (float)Math.pow(i,b?1:0); }
	public static float pow(int i1, int i2) { return (float)Math.pow(i1,i2); }
	public static float pow(int i, float f) { return (float)Math.pow(i,f); }
	public static double pow(int i, double d) { return Math.pow(i,d); }
	public static String pow(int i, String s) { return i+"^"+s; }
	public static float pow(int i, MelVector v) { return (float)Math.pow(i, v.length()); }
	public static float pow(int i, MelMatrix m) { return (float)Math.pow(i, m.length()); }
	public static Object pow(int i, Object o) { 
		if (o instanceof Boolean) return new Float(Math.pow(i, (((Boolean)o).booleanValue()?1:0))); 
		if (o instanceof Integer) return new Float(Math.pow(i, ((Integer)o).intValue())); 
		if (o instanceof Float) return new Float(Math.pow(i, ((Float)o).floatValue())); 
		if (o instanceof Double) return new Double(Math.pow(i, ((Double)o).doubleValue())); 
		if (o instanceof String) return i+"^"+(String)o; 
		if (o instanceof MelVector) return new Float((float)Math.pow(i, ((MelVector)o).length()));
		if (o instanceof MelMatrix) return new Float((float)Math.pow(i, ((MelMatrix)o).length()));
		return new Integer(0);
	}
	
	
	public static float pow(float f, boolean b) { return (float)Math.pow(f,b?1:0); }
	public static float pow(float f, int i) { return (float)Math.pow(f,i); }
	public static float pow(float f1, float f2) { return (float)Math.pow(f1,f2); }
	public static double pow(float f, double d) { return Math.pow(f,d); }
	public static String pow(float f, String s) { return f+"^"+s; }
	public static float pow(float f, MelVector v) { return (float)Math.pow(f, v.length()); }
	public static float pow(float f, MelMatrix m) { return (float)Math.pow(f, m.length()); }
	public static Object pow(float f, Object o) { 
		if (o instanceof Boolean) return new Float(Math.pow(f, (((Boolean)o).booleanValue()?1:0))); 
		if (o instanceof Integer) return new Float(Math.pow(f, ((Integer)o).intValue())); 
		if (o instanceof Float) return new Float(Math.pow(f, ((Float)o).floatValue())); 
		if (o instanceof Double) return new Double(Math.pow(f, ((Double)o).doubleValue())); 
		if (o instanceof String) return f+"^"+(String)o; 
		if (o instanceof MelVector) return new Float((float)Math.pow(f, ((MelVector)o).length()));
		if (o instanceof MelMatrix) return new Float((float)Math.pow(f, ((MelMatrix)o).length()));
		return new Integer(0);
	}
	
	
	public static double pow(double d, boolean b) { return Math.pow(d,b?1:0); }
	public static double pow(double d, int i) { return Math.pow(d,i); }
	public static double pow(double d, float f) { return Math.pow(d,f); }
	public static double pow(double d1, double d2) { return Math.pow(d1,d2); }
	public static String pow(double d, String s) { return d+"^"+s; }
	public static double pow(double d, MelVector v) { return Math.pow(d, v.length()); }
	public static double pow(double d, MelMatrix m) { return Math.pow(d, m.length()); }
	public static Object pow(double d, Object o) { 
		if (o instanceof Boolean) return new Double(Math.pow(d, (((Boolean)o).booleanValue()?1:0))); 
		if (o instanceof Integer) return new Double(Math.pow(d, ((Integer)o).intValue())); 
		if (o instanceof Float) return new Double(Math.pow(d, ((Float)o).floatValue())); 
		if (o instanceof Double) return new Double(Math.pow(d, ((Double)o).doubleValue())); 
		if (o instanceof String) return d+"^"+(String)o; 
		if (o instanceof MelVector) return new Double(Math.pow(d, ((MelVector)o).length()));
		if (o instanceof MelMatrix) return new Double(Math.pow(d, ((MelMatrix)o).length()));
		return new Integer(0);
	}
	
	
	public static String pow(String s, boolean b) { return s+"^"+(b?"1":"0"); }
	public static String pow(String s, int i) { return s+"^"+i; }
	public static String pow(String s, float f) { return s+"^"+f; }
	public static String pow(String s, double d) { return s+"^"+d; }
	public static String pow(String s1, String s2) { return s1+"^"+s2; }
	public static String pow(String s, MelVector v) { return s+"^"+v.toString(); }
	public static String pow(String s, MelMatrix m) { return s+"^"+m.toString(); }
	public static String pow(String s, Object o) { return s+"^"+o.toString(); }
	
	
	public static MelVector pow(MelVector v, boolean b) { return v.pow(ConvUtils.toVector(b?1:0)); }
	public static MelVector pow(MelVector v, int i) { return v.pow(ConvUtils.toVector(i)); }
	public static MelVector pow(MelVector v, float f) { return v.pow(ConvUtils.toVector(f)); }
	public static MelVector pow(MelVector v, double d) { return v.pow(ConvUtils.toVector((float)d)); }
	public static String pow(MelVector v, String s) { return v.toString()+"^"+s; }
	public static MelVector pow(MelVector v1, MelVector v2) { return v1.pow(v2); }
	public static MelVector pow(MelVector v, MelMatrix m) { return v.pow(ConvUtils.toVector(m)); }
	public static Object pow(MelVector v, Object o) { 
		if (o instanceof Boolean) return v.pow(ConvUtils.toVector(((Boolean)o).booleanValue()?1:0)); 
		if (o instanceof Integer) return v.pow(ConvUtils.toVector(((Integer)o).intValue())); 
		if (o instanceof Float) return v.pow(ConvUtils.toVector(((Float)o).floatValue())); 
		if (o instanceof Double) return v.pow(ConvUtils.toVector((float)((Double)o).doubleValue())); 
		if (o instanceof String) return v+"^"+(String)o; 
		if (o instanceof MelVector) return v.pow((MelVector)o); 
		if (o instanceof MelMatrix) return v.pow(ConvUtils.toVector((MelMatrix)o)); 
		return new Integer(0);
	}
	

	public static MelMatrix pow(MelMatrix m, boolean b) { return m; }
	public static MelMatrix pow(MelMatrix m, int i) { return m; }
	public static MelMatrix pow(MelMatrix m, float f) { return m; }
	public static MelMatrix pow(MelMatrix m, double d) { return m; }
	public static String pow(MelMatrix m, String s) { return m.toString()+"^"+s; }
	public static MelMatrix pow(MelMatrix m, MelVector v) { return m; }
	public static MelMatrix pow(MelMatrix m1, MelMatrix m2) { return m1; }
	public static MelMatrix pow(MelMatrix m, Object o) { return m; }
	

	public static Object pow(Object o, boolean b) { return pow(o, new Boolean(b)); }
	public static Object pow(Object o, int i) { return pow(o, new Integer(i)); }
	public static Object pow(Object o, float f) { return pow(o, new Float(f)); }
	public static Object pow(Object o, double d) { return pow(o, new Double(d)); }
	public static String pow(Object o, String s) { return o.toString()+"^"+s; }
	public static Object pow(Object o, MelVector v) { 
		if (o instanceof Integer) return new Float(pow(((Integer)o).intValue(), v)); 
		if (o instanceof Boolean) return new Float(pow(((Boolean)o).booleanValue(), v)); 
		if (o instanceof Float) return new Float(pow(((Float)o).floatValue(), v)); 
		if (o instanceof Double) return new Float(pow(((Double)o).doubleValue(), v)); 
		if (o instanceof String) return o+"^"+v.toString(); 
		if (o instanceof MelVector) return pow((MelVector)o, v); 
		if (o instanceof MelMatrix) return pow((MelMatrix)o, v); 
		return new Integer(0);
	}
	public static Object pow(Object o, MelMatrix m) { 
		if (o instanceof Integer) return new Float(pow(((Integer)o).intValue(), m)); 
		if (o instanceof Boolean) return new Float(pow(((Boolean)o).booleanValue(), m)); 
		if (o instanceof Float) return new Float(pow(((Float)o).floatValue(), m)); 
		if (o instanceof Double) return new Float(pow(((Double)o).doubleValue(), m)); 
		if (o instanceof String) return o+"^"+m.toString(); 
		if (o instanceof MelVector) return pow((MelVector)o, m); 
		if (o instanceof MelMatrix) return pow((MelMatrix)o, m); 
		return new Integer(0);
	}
	public static Object pow(Object o1, Object o2) { 
		if (o2 instanceof Integer) return pow(o1, ((Integer)o2).intValue()); 
		if (o2 instanceof Boolean) return pow(o1, ((Boolean)o2).booleanValue()); 
		if (o2 instanceof Float) return pow(o1, ((Float)o2).floatValue()); 
		if (o2 instanceof Double) return pow(o1, ((Double)o2).doubleValue()); 
		if (o2 instanceof String) return pow(o1, (String)o2); 
		if (o2 instanceof MelVector) return pow(o1, (MelVector)o2); 
		if (o2 instanceof MelMatrix) return pow(o1, (MelMatrix)o2); 
		return new Integer(0);
	}
}