package jmel.script;

public class SubUtils 
{
	public static int sub(boolean b1, boolean b2) { return (b1?1:0)-(b2?1:0); }
	public static int sub(boolean b, int i2) { return (b?1:0)-i2; }
	public static float sub(boolean b, float f) { return (b?1:0)-f; }
	public static double sub(boolean b, double d) { return (b?1:0)-d; }
	public static String sub(boolean b, String s) { return b+"-"+s; }
	public static MelVector sub(boolean b, MelVector v) { return ConvUtils.toVector(b?1:0).sub(v); }
	public static MelMatrix sub(boolean b, MelMatrix m) { return ConvUtils.toMatrix(b).sub(m); }
	public static Object sub(boolean b, Object o) { 
		int value = b ? 1 : 0;
		if (o instanceof Boolean) return new Integer(value-(((Boolean)o).booleanValue()?1:0)); 
		if (o instanceof Integer) return new Integer(value-((Integer)o).intValue()); 
		if (o instanceof Float) return new Float(value-((Float)o).floatValue()); 
		if (o instanceof Double) return new Double(value-((Double)o).doubleValue()); 
		if (o instanceof String) return b+"-"+(String)o; 
		if (o instanceof MelVector) return ConvUtils.toVector(value).sub((MelVector)o); 
		if (o instanceof MelMatrix) return ConvUtils.toMatrix(value).sub((MelMatrix)o); 
		return new Integer(0);
	}


	public static int sub(int i, boolean b) { return i-(b?1:0); }
	public static int sub(int i1, int i2) { return i1-i2; }
	public static float sub(int i, float f) { return i-f; }
	public static double sub(int i, double d) { return i-d; }
	public static String sub(int i, String s) { return i+"-"+s; }
	public static MelVector sub(int i, MelVector v) { return ConvUtils.toVector(i).sub(v); }
	public static MelMatrix sub(int i, MelMatrix m) { return ConvUtils.toMatrix(i).sub(m); }
	public static Object sub(int i, Object o) { 
		if (o instanceof Boolean) return new Integer(i-(((Boolean)o).booleanValue()?1:0)); 
		if (o instanceof Integer) return new Integer(i-((Integer)o).intValue()); 
		if (o instanceof Float) return new Float(i-((Float)o).floatValue()); 
		if (o instanceof Double) return new Double(i-((Double)o).doubleValue()); 
		if (o instanceof String) return i+"-"+(String)o; 
		if (o instanceof MelVector) return ConvUtils.toVector(i).sub((MelVector)o); 
		if (o instanceof MelMatrix) return ConvUtils.toMatrix(i).sub((MelMatrix)o); 
		return new Integer(0);
	}
	
	
	public static float sub(float f, boolean b) { return f-(b?1.0F:0.0F); }
	public static float sub(float f, int i) { return f-i; }
	public static float sub(float f1, float f2) { return f1-f2; }
	public static double sub(float f, double d) { return f-d; }
	public static String sub(float f, String s) { return f+"-"+s; }
	public static MelVector sub(float f, MelVector v) { return ConvUtils.toVector(f).sub(v); }
	public static MelMatrix sub(float f, MelMatrix m) { return ConvUtils.toMatrix(f).sub(m); }
	public static Object sub(float f, Object o) {
		if (o instanceof Boolean) return new Float(f-(((Boolean)o).booleanValue()?1:0)); 
		if (o instanceof Integer) return new Float(f-((Integer)o).intValue()); 
		if (o instanceof Float) return new Float(f-((Float)o).floatValue()); 
		if (o instanceof Double) return new Double(f-((Double)o).doubleValue()); 
		if (o instanceof String) return f+"-"+(String)o; 
		if (o instanceof MelVector) return ConvUtils.toVector(f).sub((MelVector)o); 
		if (o instanceof MelMatrix) return ConvUtils.toMatrix(f).sub((MelMatrix)o); 
		return new Integer(0);
	}
	
	
	public static double sub(double d, boolean b) { return d-(b?1.0D:0.0D); }
	public static double sub(double d, int i) { return d-i; }
	public static double sub(double d, float f) { return d-f; }
	public static double sub(double d1, double d2) { return d1-d2; }
	public static String sub(double d, String s) { return d+"-"+s; }
	public static MelVector sub(double d, MelVector v) { return ConvUtils.toVector((float)d).sub(v); }
	public static MelMatrix sub(double d, MelMatrix m) { return ConvUtils.toMatrix(d).sub(m); }
	public static Object sub(double d, Object o) { 
		if (o instanceof Boolean) return new Double(d-(((Boolean)o).booleanValue()?1:0)); 
		if (o instanceof Integer) return new Double(d-((Integer)o).intValue()); 
		if (o instanceof Float) return new Double(d-((Float)o).floatValue()); 
		if (o instanceof Double) return new Double(d-((Double)o).doubleValue()); 
		if (o instanceof String) return d+"-"+(String)o; 
		if (o instanceof MelVector) return ConvUtils.toVector((float)d).sub((MelVector)o); 
		if (o instanceof MelMatrix) return ConvUtils.toMatrix(d).sub((MelMatrix)o); 
		return new Integer(0);
	}
	
	
	public static String sub(String s, boolean b) { return s+"-"+(b?"1":"0"); }
	public static String sub(String s, int i) { return s+"-"+i; }
	public static String sub(String s, float f) { return s+"-"+f; }
	public static String sub(String s, double d) { return s+"-"+d; }
	public static String sub(String s1, String s2) { return s1+"-"+s2; }
	public static String sub(String s, MelVector v) { return s+"-"+v.toString(); }
	public static String sub(String s, MelMatrix m) { return s+"-"+m.toString(); }
	public static String sub(String s, Object o) { return s+"-"+o.toString(); }
	
	
	public static MelVector sub(MelVector v, boolean b) { return v.sub(b?1:0); }
	public static MelVector sub(MelVector v, int i) { return v.sub(i); }
	public static MelVector sub(MelVector v, float f) { return v.sub(f); }
	public static MelVector sub(MelVector v, double d) { return v.sub((float)d); }
	public static String sub(MelVector v, String s) { return v.toString()+"-"+s; }
	public static MelVector sub(MelVector v1, MelVector v2) { return v1.sub(v2); }
	public static MelVector sub(MelVector v, MelMatrix m) { return v.sub(ConvUtils.toVector(m)); }
	public static Object sub(MelVector v, Object o) { 
		if (o instanceof Boolean) return v.sub(((Boolean)o).booleanValue()?1:0); 
		if (o instanceof Integer) return v.sub(((Integer)o).intValue()); 
		if (o instanceof Float) return v.sub(((Float)o).floatValue()); 
		if (o instanceof Double) return v.sub((float)((Double)o).doubleValue()); 
		if (o instanceof String) return v+"-"+(String)o; 
		if (o instanceof MelVector) return v.sub((MelVector)o); 
		if (o instanceof MelMatrix) return v.sub(ConvUtils.toVector((MelMatrix)o)); 
		return new Integer(0);
	}
	

	public static MelMatrix sub(MelMatrix m, boolean b) { return m.sub(ConvUtils.toMatrix(b?1:0)); }
	public static MelMatrix sub(MelMatrix m, int i) { return m.sub(ConvUtils.toMatrix(i)); }
	public static MelMatrix sub(MelMatrix m, float f) { return m.sub(ConvUtils.toMatrix(f)); }
	public static MelMatrix sub(MelMatrix m, double d) { return m.sub(ConvUtils.toMatrix((float)d)); }
	public static String sub(MelMatrix m, String s) { return m.toString()+"-"+s; }
	public static MelMatrix sub(MelMatrix m, MelVector v) { return m.sub(ConvUtils.toMatrix(v)); }
	public static MelMatrix sub(MelMatrix m1, MelMatrix m2) { return m1.sub(m2); }
	public static Object sub(MelMatrix m, Object o) { 
		if (o instanceof Boolean) return m.sub(ConvUtils.toMatrix(((Boolean)o).booleanValue()?1:0)); 
		if (o instanceof Integer) return m.sub(ConvUtils.toMatrix(((Integer)o).intValue())); 
		if (o instanceof Float) return m.sub(ConvUtils.toMatrix(((Float)o).floatValue())); 
		if (o instanceof Double) return m.sub(ConvUtils.toMatrix((float)((Double)o).doubleValue())); 
		if (o instanceof String) return m+"-"+(String)o; 
		if (o instanceof MelVector) return m.sub(ConvUtils.toMatrix((MelVector)o)); 
		if (o instanceof MelMatrix) return m.sub((MelMatrix)o); 
		return new Integer(0);
	}
	

	public static Object sub(Object o, boolean b) { return sub(o, new Boolean(b)); }
	public static Object sub(Object o, int i) { return sub(o, new Integer(i)); }
	public static Object sub(Object o, float f) { return sub(o, new Float(f)); }
	public static Object sub(Object o, double d) { return sub(o, new Double(d)); }
	public static String sub(Object o, String s) { return o.toString()+"-"+s; }
	public static Object sub(Object o, MelVector v) { 
		if (o instanceof Integer) return sub(((Integer)o).intValue(), v); 
		if (o instanceof Boolean) return sub(((Boolean)o).booleanValue(), v); 
		if (o instanceof Float) return sub(((Float)o).floatValue(), v); 
		if (o instanceof Double) return sub(((Double)o).doubleValue(), v); 
		if (o instanceof String) return o+"-"+v.toString(); 
		if (o instanceof MelVector) return sub((MelVector)o, v); 
		if (o instanceof MelMatrix) return sub((MelMatrix)o, v); 
		return new Integer(0);
	}
	public static Object sub(Object o, MelMatrix m) { 
		if (o instanceof Integer) return sub(((Integer)o).intValue(), m); 
		if (o instanceof Boolean) return sub(((Boolean)o).booleanValue(), m); 
		if (o instanceof Float) return sub(((Float)o).floatValue(), m); 
		if (o instanceof Double) return sub(((Double)o).doubleValue(), m); 
		if (o instanceof String) return o+"-"+m.toString(); 
		if (o instanceof MelVector) return sub((MelVector)o, m); 
		if (o instanceof MelMatrix) return sub((MelMatrix)o, m); 
		return new Integer(0);
	}
	public static Object sub(Object o1, Object o2) { 
		if (o2 instanceof Integer) return sub(o1, ((Integer)o2).intValue()); 
		if (o2 instanceof Boolean) return sub(o1, ((Boolean)o2).booleanValue()); 
		if (o2 instanceof Float) return sub(o1, ((Float)o2).floatValue()); 
		if (o2 instanceof Double) return sub(o1, ((Double)o2).doubleValue()); 
		if (o2 instanceof String) return sub(o1, (String)o2); 
		if (o2 instanceof MelVector) return sub(o1, (MelVector)o2); 
		if (o2 instanceof MelMatrix) return sub(o1, (MelMatrix)o2); 
		return new Integer(0);
	}
}