package jmel.script;

public class SwitchUtils
{
	public static class Case
	{
		private Object value;
		public Case(boolean b) { value = new Integer(b?1:0); }
		public Case(int b) { value = new Integer(b); }
		public Case(float b) { value = new Float(b); }
		public Case(double b) { value = new Double(b); }
		public Case(String b) { value = b; }
		public Case(MelVector b) { value = b; }
		public Case(Object b) { value = b; }
		
		public boolean equals(Case c) { return value != null && value.equals(c.value); }
	}

	public static class Switch extends Case {
		public Switch(boolean b) { super(b); }
		public Switch(int b) { super(b); }
		public Switch(float b) { super(b); }
		public Switch(double b) { super(b); }
		public Switch(Object b) { super(b); }
		public Switch(String b) { super(b); }
		public Switch(MelVector b) { super(b); }
	}

	public static class Default extends Case {
		public Default() { super((Object)null); }
	}
		
	public static int test(Switch switche, Case[] cases) {
		for (int i = 0; i < cases.length; i++)
			if (switche.equals(cases[i])) return i;
		return -1;
	}
}

