package jmel.tree;

import java.io.*;
import jmel.util.*;
import jmel.tree.Tree.*;

/**
 * Prints out a tree as indented Java core statements.
 */
public class Core extends Pretty {
	public Core(PrintStream out) {
		super(out);
	}
	
	public Core() {}

	public void printCore(Tree t) {
		String name = t.getClass().getName();
		if (name.indexOf("$") != -1) name = name.substring(name.indexOf("$") + 1);
		else if (name.lastIndexOf(".") != -1) name = name.substring(name.lastIndexOf(".") + 1);
		print("[" + name + "]");
	}

	public void printExpr(Tree tree, int prec) {
		if (tree != null) printCore(tree);
		super.printExpr(tree, prec);
	}

	public void _case(Tree tree) {
		printCore(tree);
	}
}
